summaryrefslogtreecommitdiff
path: root/libre/mkpxelinux
diff options
context:
space:
mode:
authorAndré Fabian Silva Delgado <emulatorman@parabola.nu>2014-09-02 06:41:22 -0300
committerAndré Fabian Silva Delgado <emulatorman@parabola.nu>2014-09-02 06:41:22 -0300
commitfcce4e670cd2d81990b3f50e8a682b44d40a73cc (patch)
tree2634d6d68316f3f4dd51f378e826da884a919288 /libre/mkpxelinux
parentc5822ca785d156da9849d5e25dc79a93d1fac22d (diff)
remove parabola suffix and add complex pkgrel on the packages
Diffstat (limited to 'libre/mkpxelinux')
-rw-r--r--libre/mkpxelinux/PKGBUILD29
-rw-r--r--libre/mkpxelinux/boot.msg14
-rwxr-xr-xlibre/mkpxelinux/mkpxelinux91
-rw-r--r--libre/mkpxelinux/mkpxelinux.conf37
-rw-r--r--libre/mkpxelinux/options.msg6
5 files changed, 177 insertions, 0 deletions
diff --git a/libre/mkpxelinux/PKGBUILD b/libre/mkpxelinux/PKGBUILD
new file mode 100644
index 000000000..2105d70dd
--- /dev/null
+++ b/libre/mkpxelinux/PKGBUILD
@@ -0,0 +1,29 @@
+# $Id: PKGBUILD 197074 2013-10-21 15:42:46Z tpowa $
+# Maintainer (Arch): Tobias Powalowski <tpowa@archlinux.org>
+
+pkgname=mkpxelinux
+pkgver=2013.10
+pkgrel=1.parabola1
+pkgdesc="Advanced, modular network pxe boot image creation utility (Parabola rebranded)"
+arch=(any)
+license=('GPL')
+url="https://parabolagnulinux.org/"
+depends=('mkinitcpio' 'tftp-hpa' 'syslinux')
+replaces=(${pkgname}-parabola)
+conflicts=(${pkgname}-parabola)
+backup=(etc/mkpxelinux.conf)
+optdepends=('dhcp: for dhcp server usage')
+source=('boot.msg' 'mkpxelinux' 'mkpxelinux.conf' 'options.msg')
+
+package()
+{
+ cd "$srcdir/"
+ install -D -m755 mkpxelinux "$pkgdir/usr/bin/mkpxelinux"
+ install -D -m644 mkpxelinux.conf "$pkgdir/etc/mkpxelinux.conf"
+ install -D -m644 boot.msg "$pkgdir/usr/share/mkpxelinux/boot.msg"
+ install -D -m644 options.msg "$pkgdir/usr/share/mkpxelinux/options.msg"
+}
+md5sums=('7225e73bfe717f97bd7ab52f5ab157f6'
+ '44c6b9fa8ae668a432f26adb9e70bd3f'
+ '158dece3af889740b0f0ee397f9058ed'
+ 'ae0007d6679b5a575b2a9e5ac3664baf')
diff --git a/libre/mkpxelinux/boot.msg b/libre/mkpxelinux/boot.msg
new file mode 100644
index 000000000..6c1fcd476
--- /dev/null
+++ b/libre/mkpxelinux/boot.msg
@@ -0,0 +1,14 @@
+
+
+------------------------------------------------------------------------------
+Parabola GNU/Linux-libre
+PXELINUX BOOT
+created with 'mkpxelinux' written by Tobias Powalowski <tpowa@archlinux.org>
+
+Press ENTER or type 'parabola' to boot image.
+
+If you wish to change your defaults to boot into your existing system,
+type 'vmlinuz initrd=initrd.img <any_other_boot_option>'
+Use the F2 key for troubleshooting and options.
+------------------------------------------------------------------------------
+
diff --git a/libre/mkpxelinux/mkpxelinux b/libre/mkpxelinux/mkpxelinux
new file mode 100755
index 000000000..35e946f82
--- /dev/null
+++ b/libre/mkpxelinux/mkpxelinux
@@ -0,0 +1,91 @@
+#! /bin/sh
+# Created by Tobias Powalowski <tpowa@archlinux.org>
+# Rebranded for Parabola by André Silva <emulatorman@parabola.nu>
+# Settings
+APPNAME=$(basename "${0}")
+CONFIG="/etc/mkpxelinux.conf"
+
+usage ()
+{
+ echo "${APPNAME}: usage"
+ echo""
+ echo " -d=INSTALLDIR Your INSTALLDIR overwrites config default"
+ echo " -c=CONFIG Use CONFIG file. default: /etc/mkpxelinux.conf"
+ echo " -h This message."
+ exit 1
+}
+
+[ "$1" == "" ] && usage && exit 1
+
+while [ $# -gt 0 ]; do
+ case $1 in
+ -c=*|--c=*) CONFIG="$(echo $1 | awk -F= '{print $2;}')" ;;
+ -d=*|--d=*) CUSTOMINSTALLDIR="$(echo $1 | awk -F= '{print $2;}')" ;;
+ -h|--h|?) usage ;;
+ *) usage ;;
+ esac
+ shift
+done
+
+if [ ! -f "${CONFIG}" ]; then
+ echo "config file '${CONFIG}' cannot be found, aborting..."
+ exit 1
+fi
+
+. "${CONFIG}"
+# export for mkinitcpio
+[ -n "${APPENDBOOTMESSAGE}" ] && export APPENDBOOTMESSAGE
+[ -n "${APPENDOPTIONSBOOTMESSAGE}" ] && export APPENDOPTIONSBOOTMESSAGE
+
+! [ "${CUSTOMINSTALLDIR}" = "" ] && INSTALLDIR=${CUSTOMINSTALLDIR}
+
+if [ "${INSTALLDIR}" = "" ]; then
+ echo "ERROR: No INSTALLDIR name specified, please use the -d option"
+ exit 1
+fi
+
+if ! [ $UID -eq 0 ]; then
+ echo "ERROR: only works when run as root!"
+ exit 1
+fi
+
+! [ -e ${INSTALLDIR} ] && echo "No ${INSTALLDIR} found!" && exit 1
+export TEMPDIR=${NFSROOTDIR}
+export INSTALLDIR=${INSTALLDIR}
+export RUNPROGRAM="${APPNAME}"
+[ "${BOOTMESSAGE}" = "" ] && export BOOTMESSAGE=$(mktemp /tmp/bootmessage.XXXX)
+[ "${OPTIONSBOOTMESSAGE}" = "" ] && export OPTIONSBOOTMESSAGE=$(mktemp /tmp/optionsbootmessage.XXXX)
+export USEKERNEL=${VERSION}
+# begin script
+# create default
+echo ":: Creating pxelinux default config file ..."
+mkdir -p ${INSTALLDIR}/pxelinux.cfg
+if [ "${PXELINUX_DEFAULT}" = "" ]; then
+ [ -e ${INSTALLDIR}/pxelinux.cfg/default ] && rm ${INSTALLDIR}/pxelinux.cfg/default
+ echo "prompt ${PROMPT}" >> ${INSTALLDIR}/pxelinux.cfg/default
+ echo "timeout ${TIMEOUT}" >> ${INSTALLDIR}/pxelinux.cfg/default
+ echo "display boot.msg" >> ${INSTALLDIR}/pxelinux.cfg/default
+ echo "F1 boot.msg" >> ${INSTALLDIR}/pxelinux.cfg/default
+ echo "F2 options.msg" >> ${INSTALLDIR}/pxelinux.cfg/default
+ echo "default parabola" >> ${INSTALLDIR}/pxelinux.cfg/default
+ echo "label parabola" >> ${INSTALLDIR}/pxelinux.cfg/default
+ echo "kernel vmlinuz" >> ${INSTALLDIR}/pxelinux.cfg/default
+ echo "append initrd=initrd.img ${KERNEL_BOOT_OPTIONS}" >> ${INSTALLDIR}/pxelinux.cfg/default
+else
+ sed "s|@@PROMPT@@|${PROMPT}|g;s|@@TIMEOUT@@|${TIMEOUT}|g;s|@@KERNEL_BOOT_OPTIONS@@|${KERNEL_BOOT_OPTIONS}|g" \
+ ${PXELINUX_DEFAULT} > ${INSTALLDIR}/pxelinux.cfg/default
+fi
+[ ! -s ${INSTALLDIR}/pxelinux.cfg/default ] && echo "No pxelinux default config found" && exit 1
+echo ":: Calling mkinitcpio CONFIG=${MKINITCPIO_CONFIG} KERNEL=${VERSION} ..."
+# generate initramdisk
+echo ":: Creating initramdisk ..."
+ mkinitcpio -c ${MKINITCPIO_CONFIG} -k ${VERSION} -g ${INSTALLDIR}/initrd.img
+echo ":: Using ${KERNEL} as image kernel ..."
+ install -m644 ${KERNEL} ${INSTALLDIR}/vmlinuz
+echo ":: Installing message files to ${INSTALLDIR} ..."
+ install -m644 ${BOOTMESSAGE} ${INSTALLDIR}/boot.msg
+ install -m644 ${OPTIONSBOOTMESSAGE} ${INSTALLDIR}/options.msg
+ [ ! -s ${INSTALLDIR}/boot.msg ] && echo 'ERROR:no boot.msg found, aborting!' && exit 1
+ [ ! -s ${INSTALLDIR}/options.msg ] && echo 'ERROR:no options.msg found, aborting!' && exit 1
+echo ":: Installing PXELINUX to ${INSTALLDIR} ..."
+ install -m644 /usr/lib/syslinux/bios/pxelinux.0 ${INSTALLDIR}/pxelinux.0 && echo "Installation completed."
diff --git a/libre/mkpxelinux/mkpxelinux.conf b/libre/mkpxelinux/mkpxelinux.conf
new file mode 100644
index 000000000..55aba8247
--- /dev/null
+++ b/libre/mkpxelinux/mkpxelinux.conf
@@ -0,0 +1,37 @@
+# Created by Tobias Powalowski <tpowa@archlinux.org>
+# Rebranded for Parabola by André Silva <emulatorman@parabola.nu>
+# config file of mkpxelinux
+
+# DEFAULT kernel boot options like ip=:::::eth0:dhcp etc.
+# add your root= option, if you boot from a disk device
+# and don't want to add it by hand on each boot
+KERNEL_BOOT_OPTIONS=""
+
+# mkinitcpio config file, defaulted to stock config file
+MKINITCPIO_CONFIG="/etc/mkinitcpio.conf"
+
+# kernel version, defaulted to build for runtime kernel
+VERSION="$(uname -r)"
+
+# kernel image, defaulted to stock libre kernel
+KERNEL="/boot/vmlinuz-linux-libre"
+
+# boot message files
+BOOTMESSAGE="/usr/share/mkpxelinux/boot.msg"
+OPTIONSBOOTMESSAGE="/usr/share/mkpxelinux/options.msg"
+
+#pxelinux default config file to use
+PXELINUX_DEFAULT=""
+
+# Prompt on boot, 1=yes 0=no
+PROMPT="1"
+
+# Timeout, 30 seconds to fix usb keyboard issues
+# 0 means wait for prompt
+TIMEOUT="300"
+
+# Installdir of tftp, default location
+INSTALLDIR="/var/tftpboot"
+
+# Nfsrootdir, for hooks that might need it
+NFSROOTDIR=""
diff --git a/libre/mkpxelinux/options.msg b/libre/mkpxelinux/options.msg
new file mode 100644
index 000000000..16c6b2eda
--- /dev/null
+++ b/libre/mkpxelinux/options.msg
@@ -0,0 +1,6 @@
+------------------------------------------------------------------------------
+Parabola GNU/Linux-libre options and troubleshooting:
+
+- If your system hangs during the boot process, any combinations of the
+ boot options noapic acpi=off pci=routeirq nosmp nomsi may be useful.
+------------------------------------------------------------------------------